#include "common.h"

///
/// EXTENSION CONSTRUCTOR/DESTRUCTOR
///

Extension::Extension(LPRDATA _rdPtr, LPEDATA edPtr, fpcob cobPtr)
    : rdPtr(_rdPtr), rhPtr(_rdPtr->rHo.hoAdRunHeader), Runtime(_rdPtr)
{
    /*
        Link all your action/condition/expression functions to their IDs to match the
        IDs in the JSON here
    */

	UltraDebug("Extension() began; link starting.");
/// ACTIONS

	LinkAction(0, FileServers_BootNewServer);

/// CONDITIONS
	LinkCondition(0, AllServers_OnUserConnected);
	LinkCondition(1, AllServers_OnUserIdentity_Set);
	LinkCondition(2, AllServers_OnUserIdentity_SetDenied);
	LinkCondition(3, AllServers_OnUserDisconnected);
	LinkCondition(4, AllNodes_OnLocalError);
	UltraDebug("Link done; initialising variables.");

    /*
        This is where you'd do anything you'd do in CreateRunObject in the original SDK

        It's the only place you'll get access to edPtr at runtime, so you should transfer
        anything from edPtr to the extension class here.
    
    */

	// Content stripped
	Lacewing::SpinSync::WriteLock WL(ExtensionThreadLock);
	UltraDebug("AppEventPump initialised.");
	AppEventPump = Lacewing::EventPump::EventPump();

	Debug("Initialisation of MMF link complete.");
	WL.Release();
}

Extension::~Extension()
{
    /*
        This is where you'd do anything you'd do in DestroyRunObject in the original SDK.
        (except calling destructors and other such atrocities, because that's automatic in Edif)
    */

	// Loop while the size is greater than 0
	while(DarknetLocalNodeIDs.size())
	{
		// Delete if a valid pointer, else just pop back
		if(DarknetLocalNodeIDs.back())
			delete DarknetLocalNodeIDs.back();
		DarknetLocalNodeIDs.pop_back();
	}


}


short Extension::Handle()
{
    /*
       If your extension will draw to the MMF window you should first 
       check if anything about its display has changed :

           if (rdPtr->roc.rcChanged)
              return REFLAG_DISPLAY;
           else
              return 0;

       You will also need to make sure you change this flag yourself 
       to 1 whenever you want to redraw your object
     
       If your extension won't draw to the window, but it still needs 
       to do something every MMF loop use :

            return 0;

       If you don't need to do something every loop, use :

            return REFLAG_ONESHOT;

       This doesn't mean this function can never run again. If you want MMF
       to handle your object again (causing this code to run) use this function:

            Runtime.Rehandle();

       At the end of the loop this code will run

    */
	AppEventPump.Tick();
	return 0;
}


short Extension::Display()
{
    /*
       If you return REFLAG_DISPLAY in Handle() this routine will run.
    */

    // Ok
    return 0;
}

short Extension::Pause()
{

    // Ok
    return 0;
}

short Extension::Continue()
{

    // Ok
    return 0;
}

bool Extension::Save(HANDLE File)
{
	bool OK = false;

    #ifndef VITALIZE

	    // Save the object's data here

	    OK = true;

    #endif

	return OK;
}

bool Extension::Load(HANDLE File)
{
	bool OK = false;

    #ifndef VITALIZE

	    // Load the object's data here

	    OK = true;

    #endif

	return OK;
}


// These are called if there's no function linked to an ID

void Extension::Action(int ID, LPRDATA rdPtr, long param1, long param2)
{
	char t [50];
	sprintf_s(t, 50, "Action not set up: ID %i.", ID);
	MessageBoxA(NULL, t, "Extracted server error", MB_OK);
}

long Extension::Condition(int ID, LPRDATA rdPtr, long param1, long param2)
{
	char t [50];
	sprintf_s(t, 50, "Condition not set up: ID %i.", ID);
	MessageBoxA(NULL, t, "Extracted server object error", MB_OK);
    return false;
}

long Extension::Expression(int ID, LPRDATA rdPtr, long param)
{
	char t [50];
	sprintf_s(t, 50, "Expression not set up: ID %i.", ID);
	MessageBoxA(NULL, t, "Extracted server error", MB_OK);
    return 0;
}

