// LacewingRelocater.h
// Header for the file that moves all generic Lacewing requests to the associated Darknet server/client function.

#include "..\Inc\Lacewing.h"
// SERVER
bool OnSetName(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, const char * Name);
bool OnConnect(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client);
void OnDisconnect(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client);
void OnError(Lacewing::RelayServer &Server, Lacewing::Error &Error);
void OnError(Lacewing::FlashPolicy &FlashPolicy, Lacewing::Error &Error);
void OnServerMessage(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, bool Blasted, int Subchannel, char * Data, int Size, int Variant);
bool OnChannelMessage(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel, bool Blasted, int Subchannel, char * Data, int Size, int Variant);
bool OnPeerMessage(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel, Lacewing::RelayServer::Client &TargetClient, bool Blasted, int Subchannel, char * Packet, int Size, int Variant);
bool OnJoinChannel(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel);
bool OnLeaveChannel(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel);
// CLIENT
void OnChannelListReceived(Lacewing::RelayClient &Client);
void OnChannelMessage(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Channel, Lacewing::RelayClient::Channel::Peer &Peer, bool Blasted, int Subchannel, char * Data, int Size, int Variant);
void OnConnect(Lacewing::RelayClient &Client);
void OnConnectDenied(Lacewing::RelayClient &Client, const char * DenyReason);
void OnError(Lacewing::RelayClient &Client, Lacewing::Error &Error);
void OnChannelJoin(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Target);
void OnChannelJoinDenied(Lacewing::RelayClient &Client, const char * ChannelName, const char * DenyReason);
void OnChannelLeave(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Target);
void OnChannelLeaveDenied(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Target, const char * DenyReason);
void OnNameChanged(Lacewing::RelayClient &Client, const char * OldName);
void OnNameSet(Lacewing::RelayClient &Client);
void OnNameDenied(Lacewing::RelayClient &Client, const char * Name, const char * DenyReason);
void OnPeerChangedName(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Channel, Lacewing::RelayClient::Channel::Peer &Peer, const char * OldName);
void OnPeerConnect(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Channel, Lacewing::RelayClient::Channel::Peer &Peer);
void OnPeerDisconnect(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Channel, Lacewing::RelayClient::Channel::Peer &Peer);
void OnPeerMessage(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Channel, Lacewing::RelayClient::Channel::Peer &Peer, bool Blasted, int Subchannel, char * Data, int Size, int Variant);
void OnServerChannelMessage(Lacewing::RelayClient &Client, Lacewing::RelayClient::Channel &Channel, bool Blasted, int Subchannel, char * Data, int Size, int Variant);
void OnServerMessage(Lacewing::RelayClient &Client, bool Blasted, int Subchannel, char * Data, int Size, int Variant);
void OnDisconnect(Lacewing::RelayClient &Client);