#include "ServerData.h"
// If defined, outputs a debug message if a pure virtual function is executed, rather than crashing.
#ifdef PURE_VIRTUAL_DEFENCE
#define F(N) {Debug("CRITICAL ERROR: Pure virtual function executed: SERVER::"##N"(). It should have applied to node type \"%s\". The function has been ignored.", NodeType);}
virtual bool SERVER::OnConnect(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client) F("OnConnect")
virtual void SERVER::OnDisconnect(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client) F("OnDisconnect")
virtual void SERVER::OnError(Lacewing::RelayServer &Server, Lacewing::Error &Error) F("OnError{Reg}")
virtual void SERVER::OnError(Lacewing::FlashPolicy &FlashPolicy, Lacewing::Error &Error) F("OnError{Flash}")
virtual void SERVER::OnServerMessage(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, bool Blasted, int Subchannel, char * Data, int Size, int Variant) F("OnServerMessage")
virtual bool SERVER::OnChannelMessage(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel, bool Blasted, int Subchannel, char * Data, int Size, int Variant) F("OnChannelMessage")
virtual bool SERVER::OnPeerMessage(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel, Lacewing::RelayServer::Client &TargetClient, bool Blasted, int Subchannel, char * Packet, int Size, int Variant) F("OnPeerMessage")
virtual bool SERVER::OnJoinChannel(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel) F("OnJoinChannel")
virtual bool SERVER::OnLeaveChannel(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, Lacewing::RelayServer::Channel &Channel) F("OnLeaveChannel")
virtual bool SERVER::OnSetName(Lacewing::RelayServer &Server, Lacewing::RelayServer::Client &Client, const char * Name) F("OnSetName")

#undef F
#endif
