#pragma once

// #define TGFEXT       // TGF2, MMF2, MMF2 Dev
#define MMFEXT			// MMF2, MMF2 Dev
// #define PROEXT       // MMF2 Dev only


////////////////////////////////////////////////////////////////////////////////////////////////
// ADVANCED DEBUG
////////////////////////////////////////////////////////////////////////////////////////////////
#define USE_ADVANCED_DEBUG
#define DEBUG_LEVEL 3 // Set this from 0-3 for levels of debug.
//#define HALT_ON_DEBUG_MESSAGE //Define this to halt the program by infinite-while-loop
//#define USE_DEFINE_AS_DEBUG // if defined, uses #define for debug function. Otherwise it calls a function.
#include	"Debug.h"
#include	"LacewingRelocater.h"

////////////////////////////////////////////////////////////////////////////////////////////////
// EDIF FILES
////////////////////////////////////////////////////////////////////////////////////////////////
#include    "Edif.h"
#include	"Resource.h"
#include	<vector>
#include	<sstream>
#include	<regex>

#include	<winnt.h>
#include	<basetsd.h>
#include	<limits.h>
#ifndef MAXUSHORT
#define MAXUSHORT 0xffff
#endif
#ifndef MAXUCHAR
#define MAXUCHAR 0xff
#endif
#ifndef T_MAXUSHORT
#define T_MAXUSHORT "65535"
#endif
#ifndef T_MAXUCHAR
#define T_MAXUCHAR "255"
#endif
#ifndef T_MAXSHORT
#define T_MAXSHORT "32767"
#define T_MAXSSHORT T_MAXSHORT
#endif
#ifndef T_MAXCHAR
#define T_MAXCHAR "127"
#define T_MAXSCHAR T_MAXCHAR
#endif

// rTemplate include
#define NOTOLD 1
// Useful macros


// edPtr : Used at edittime and saved in the MFA/CCN/EXE files
struct EDITDATA
{
	// Header - required
	extHeader		eHeader;

	// Object's data
//	short			swidth;
//	short			sheight;

};

// See Debug.h
#if (defined(USE_ADVANCED_DEBUG) && !defined(USE_DEFINE_AS_DEBUG))
void TrueFunc(int line,  const char * file, unsigned int level, const char * output, ...);
#endif

// Threads
void WINAPI FileServer_TimedTransferThread(LPVOID);

class Extension; // Given for RUNDATA below
struct RUNDATA
{
	// Main header - required
	headerObject rHo;

	// Optional headers - depend on the OEFLAGS value, see documentation and examples for more info
//	rCom			rc;				// Common structure for movements & animations
//	rMvt			rm;				// Movements
//	rSpr			rs;				// Sprite (displayable objects)
	rVal			rv;				// Alterable values

    // Required
	Extension * pExtension;

    /*
        You shouldn't add any variables or anything here. Add them as members
        of the Extension class (Extension.h) instead.
    */
};

#include	"Extension.h"